package components

import (
	"context"

	"github.com/urfave/cli/v2"
	"go-micro.dev/v4/server"
)

type Component interface {
	Name() string
	Priority() int
	Initialized() bool
	Init(components *Components, cli *cli.Context) error
	Stop() error
	Flags(r *Components, flags []cli.Flag) []cli.Flag
	Health(context context.Context) error

	WrapHandlerFunc(ctx context.Context, req server.Request, rsp interface{}) error
}
